package to.msn.wings.gihyo.chap10.asynctaskbasic;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.os.AsyncTask;
import android.os.SystemClock;
import android.util.Log;
import android.widget.TextView;

public class MyAsyncTask extends AsyncTask<String, Integer, String> {
  private TextView txtResult;
  
  public MyAsyncTask(TextView txtResult) { 
    super();
    this.txtResult = txtResult;
  }

  @Override
  protected String doInBackground(String... params) {
    String result = null;
    SystemClock.sleep(10000); 
    publishProgress(30);
      try {
        HttpGet req = new HttpGet(params[0]);
        DefaultHttpClient client = new DefaultHttpClient();
        HttpResponse res = client.execute(req);
        int status = res.getStatusLine().getStatusCode();
        if(status == HttpStatus.SC_OK){
          result = EntityUtils.toString(res.getEntity(), "UTF-8");
        } else {
          result = "ステータスコード：" + status;
        }
      } catch (ClientProtocolException e) {
        e.printStackTrace();
      } catch (ParseException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      }
      publishProgress(100);
    return result;
  }
  
  @Override
  protected void onProgressUpdate(Integer... values) {
    Log.d("AsyncTask", values[0].toString());
  }

  @Override
  protected void onPostExecute(String result) {
    txtResult.setText(result);
  }

  @Override
  protected void onCancelled() {
    txtResult.setText("キャンセルされました。");
  }
}
