package to.msn.wings.gihyo.chap10.asynctaskloaderbasic;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.content.AsyncTaskLoader;
import android.content.Context;

public class MyLoader extends AsyncTaskLoader<String> {
  private String url;
  
  public MyLoader(Context context, String url) {
    super(context);
    this.url = url;
  }
  
  @Override
  public String loadInBackground() {
    String result = null;
    try {
      HttpGet req = new HttpGet(url);
      DefaultHttpClient client = new DefaultHttpClient();
      HttpResponse res = client.execute(req);
      int status = res.getStatusLine().getStatusCode();
      if(status == HttpStatus.SC_OK){
        result = EntityUtils.toString(res.getEntity(), "UTF-8");
      } else {
        result = "エラーコード：" + status;
      }
    } catch (ClientProtocolException e) {
      e.printStackTrace();
    } catch (ParseException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    }
    return result;
  }

}
