package to.msn.wings.gihyo.chap9.jsonread;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    TextView txtResult = (TextView)this.findViewById(R.id.txtResult);
    
    try {
      HttpGet req = new HttpGet("http://www.wings.msn.to/tmp/books.json");
      DefaultHttpClient client = new DefaultHttpClient();
      HttpResponse res = client.execute(req);
      int status = res.getStatusLine().getStatusCode();
      if(status == HttpStatus.SC_OK){
        JSONObject jObject = new JSONObject(
          EntityUtils.toString(res.getEntity(), "UTF-8"));
        JSONArray books = jObject.getJSONArray("books");
        for (int i = 0; i < books.length(); i++){
          JSONObject book = books.getJSONObject(i);
          txtResult.append(book.getString("title") + "\n");
        }
      } else {
        txtResult.setText( "ステータスコード：" + status);
      }
    } catch (ClientProtocolException e) {
      e.printStackTrace();
    } catch (ParseException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } catch (JSONException e) {
      e.printStackTrace();
    }
  }

  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    // Inflate the menu; this adds items to the action bar if it is present.
    getMenuInflater().inflate(R.menu.main, menu);
    return true;
  }

}
