package to.msn.wings.gihyo.chap10.sendmessage;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {
  private TextView txtResult;
  private Handler handler;
  
  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    txtResult = (TextView)this.findViewById(R.id.txtResult);
    
    handler = new Handler() {
      @Override
      public void handleMessage(Message msg) {
        if (msg.what == 1) {
          txtResult.setText((String)msg.obj);
        }
      }
    };

    Thread t = new Thread(new Runnable() {
      @Override
      public void run(){
        try {
          HttpGet req = new HttpGet("http://www.wings.msn.to/tmp/book.xml");
          DefaultHttpClient client = new DefaultHttpClient();
          HttpResponse res = client.execute(req);
          int status = res.getStatusLine().getStatusCode();
          if(status == HttpStatus.SC_OK){
            Message msg = Message.obtain(handler, 1,
              EntityUtils.toString(res.getEntity(), "UTF-8"));
            handler.sendMessage(msg);
          } else {
            txtResult.setText("ステータスコード：" + status);
          }
        } catch (ClientProtocolException e) {
          e.printStackTrace();
        } catch (ParseException e) {
          e.printStackTrace();
        } catch (IOException e) {
          e.printStackTrace();
        }
      }
    });
    t.start();
  }

  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    // Inflate the menu; this adds items to the action bar if it is present.
    getMenuInflater().inflate(R.menu.main, menu);
    return true;
  }

}
