package to.msn.wings.gihyo.chap9.xmlread;

import java.io.IOException;
import java.io.StringReader;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import android.app.Activity;
import android.os.Bundle;
import android.util.Xml;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    TextView txtResult = (TextView)this.findViewById(R.id.txtResult);

    try {
      HttpGet req = new HttpGet("http://www.wings.msn.to/tmp/book.xml");
      DefaultHttpClient client = new DefaultHttpClient();
      HttpResponse res = client.execute(req);
      int status = res.getStatusLine().getStatusCode();
      if(status == HttpStatus.SC_OK){
        XmlPullParser parser = Xml.newPullParser();
        parser.setInput(new StringReader(
          EntityUtils.toString(res.getEntity(), "UTF-8")));
        int type = parser.getEventType();
        while (type != XmlPullParser.END_DOCUMENT) {
          if (type == XmlPullParser.START_TAG) {
            String name = parser.getName();
            if (name.equals("book")) {
              for (int i = 0; i < parser.getAttributeCount(); i++) {
                txtResult.append(parser.getAttributeName(i) +
                  ":" + parser.getAttributeValue(i) + "\n");
              }
            } else {
              type = parser.next();
              if (type == XmlPullParser.TEXT) {
                txtResult.append(name + ":" + parser.getText() + "\n");
              }
            }
          }
          type = parser.next();
        }
      } else {
        txtResult.setText( "ステータスコード：" + status);
      }
    } catch (ClientProtocolException e) {
      e.printStackTrace();
    } catch (ParseException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } catch (XmlPullParserException e) {
      e.printStackTrace();
    }
  }

  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    // Inflate the menu; this adds items to the action bar if it is present.
    getMenuInflater().inflate(R.menu.main, menu);
    return true;
  }

}
