package to.msn.wings.gihyo.chap10;

import java.util.concurrent.atomic.AtomicInteger;

public class AtomicBasic{  
  private AtomicInteger count = new AtomicInteger();
  
  public static void main(String[] args) {
    AtomicBasic c = new AtomicBasic();
    c.execute();
  }
  
  public void execute() {
    final int TNUM = 500000;
    Thread[] ts = new Thread[TNUM];
    for (int i = 0; i < TNUM; i++) {
      ts[i] = new Thread(new MyRunnable(this));
      ts[i].start();
    }
    for (int i = 0; i < TNUM; i++) {
      try {
        ts[i].join();
      } catch (InterruptedException e) {
        System.out.println(e);
      }
    }
    System.out.println(count);
  }
  
  public void countUp() {
    count.getAndIncrement();
  }

  private static class MyRunnable implements Runnable {
    private AtomicBasic _counter;

    public MyRunnable(AtomicBasic counter) {
      this._counter = counter;
    }

    @Override
    public void run() {
      _counter.countUp();
    }
  }
}
