package to.msn.wings.gihyo.chap10;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class LocksBasic {
  private int count;
  private final Lock lock = new ReentrantLock();
  
  public static void main(String[] args) {
    LocksBasic c = new LocksBasic();
    c.execute();
  }
  
  public void execute() {
    final int TNUM = 500000;
    Thread[] ts = new Thread[TNUM];
    for (int i = 0; i < TNUM; i++) {
      ts[i] = new Thread(new MyRunnable(this));
      ts[i].start();
    }
    for (int i = 0; i < TNUM; i++) {
      try {
        ts[i].join();
      } catch (InterruptedException e) {
        System.out.println(e);
      }
    }
    System.out.println(count);
  }
  public void countUp() {
    lock.lock();
    try {
      count++;
    } finally {
      lock.unlock();
    }
  }
  
  private static class MyRunnable implements Runnable {
    private LocksBasic _counter;

    public MyRunnable(LocksBasic counter) {
      this._counter = counter;
    }

    @Override
    public void run() {
      _counter.countUp();
    }
  }
}
