package to.msn.wings.gihyo.chap10;

public class SynchronizedModifier{
  
  private int count;
  
  public static void main(String[] args) {
    SynchronizedModifier c = new SynchronizedModifier();
    c.execute();
  }
  
  public void execute() {
    final int TNUM = 500000;
    Thread[] ts = new Thread[TNUM];
    for (int i = 0; i < TNUM; i++) {
      ts[i] = new Thread(new MyRunnable(this));
      ts[i].start();
    }
    for (int i = 0; i < TNUM; i++) {
      try {
        ts[i].join();
      } catch (InterruptedException e) {
        System.out.println(e);
      }
    }
    System.out.println(count);
  }
  
  public synchronized void countUp() {
    count++;
  }

  private static class MyRunnable implements Runnable {
    private SynchronizedModifier _counter;

    public MyRunnable(SynchronizedModifier counter) {
      this._counter = counter;
    }

    @Override
    public void run() {
      _counter.countUp();
    }
  }
}
