package to.msn.wings.gihyo.chap10;

import java.util.Date;
import java.util.Random;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class ThreadCall implements Callable<Date> {
  @Override
  public Date call() throws Exception {
    try {
      Random r = new Random();
      Thread.sleep(r.nextInt(10000));
    } catch (Exception e) {
      e.printStackTrace();
    }
    return new Date();
  }
  public static void main(String[] args) {
    ExecutorService service = Executors.newFixedThreadPool(5);
    Future<Date> f1 = service.submit(new ThreadCall());
    Future<Date> f2 = service.submit(new ThreadCall());
    Future<Date> f3 = service.submit(new ThreadCall());
    
    try {
      System.out.println("f1:" + f1.get());
      System.out.println("f2:" + f2.get());
      System.out.println("f3:" + f3.get());
    } catch (InterruptedException e) {
      e.printStackTrace();
    } catch (ExecutionException e) {
      e.printStackTrace();
    }
    service.shutdown();
  }
}
